#include <bits/stdc++.h>

using namespace std;
#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<int> a(m);
    vector<bool> used(9, false);
    for (int i = 0; i < m; i++) {
        cin >> a[i];
        used[a[i]] = true;
    }
    vector<vector<vector<vector<int>>>> dp(n + 1,
                                           vector<vector<vector<int>>>(9, vector<vector<int>>(9, vector<int>(9, 0))));
    for (int i = 1; i <= 8; i++) {
        if (used[i]) {
            dp[1][i][i][0] = 1;
        }
    }
    for (int i = 2; i <= n; i++) {
        int sum = 0;
        for (int j = 1; j <= 8; j++) {
            for (int k = 1; k <= 8; k++) {
                for (int e = 0; e < 8; e++) {
                    sum += dp[i - 1][j][k][e];
                }
            }
        } // считаем сумму
        for (int j = 1; j <= 8; j++) {
            if (used[j]) {
                int bad = 0;
                vector<int> ball(9, 0);
                for (int k = 1; k <= 8; k++) {
                    for (int e = 0; e < j - 1; e++) {
                        bad += dp[i - 1][k][j][e];
                        ball[k] += dp[i - 1][k][j][e];
                    }
                }
                dp[i][j][j][0] = sum - bad;
                //dp[i][j][j][1, 2, 3, ..., j - 1] = 0
                for (int k = 1; k <= 8; k++) {
                    if (used[k]) {
                        for (int e = 1; e < j - 1; e++) {
                            dp[i][j][k][e] += dp[i - 1][j][k][e - 1] - ball[k];
                        }
                    }
                }
            }
        }
    }
    int sum = 0;
    for (int j = 1; j <= 8; j++) {
        for (int k = 1; k <= 8; k++) {
            for (int e = 0; e < 8; e++) {
                sum += dp[n][j][k][e];
            }
        }
    }
    cout << sum;
}
